future.h File Reference
`#include <memory>`
`#include <exception>`
`#include <utility>`
`#include <type_traits>`
`#include <pthread.h>`
`#include <glib.h>`
`#include <c++-gtk-utils/thread.h>`
`#include <c++-gtk-utils/mutex.h>`
`#include <c++-gtk-utils/callback.h>`
`#include <c++-gtk-utils/intrusive_ptr.h>`
`#include <c++-gtk-utils/shared_ptr.h>`
`#include <c++-gtk-utils/emitter.h>`
`#include <c++-gtk-utils/timeout.h>`
`#include <c++-gtk-utils/cgu_config.h>`
`#include <c++-gtk-utils/future.tpp>`

Go to the source code of this file.

## Classes

struct | Cgu::Thread::FutureThreadError
struct | Cgu::Thread::FutureWhenError
struct | Cgu::Thread::FutureHelper::WhenWrapperArg< Val >
struct | Cgu::Thread::FutureHelper::WhenWrapperArgRel< Val >
class | Cgu::Thread::Future< Val >
| A class representing a pthread thread which will provide a value. More...

## Namespaces

namespace | Cgu
namespace | Cgu::Thread
namespace | Cgu::Thread::FutureHelper

## Functions

template<class Obj , class Ret , class... Params, class... Args>
Cgu::IntrusivePtr < Cgu::Thread::Future< Ret > > | Cgu::Thread::make_future (Obj &obj, Ret(Obj::*func)(Params...), Args &&...args)
template<class Obj , class Ret , class... Params, class... Args>
Cgu::IntrusivePtr < Cgu::Thread::Future< Ret > > | Cgu::Thread::make_future (const Obj &obj, Ret(Obj::*func)(Params...) const, Args &&...args)
template<class Ret , class... Params, class... Args>
Cgu::IntrusivePtr < Cgu::Thread::Future< Ret > > | Cgu::Thread::make_future (Ret(*func)(Params...), Args &&...args)
template<class Ret , class Func >
Cgu::IntrusivePtr < Cgu::Thread::Future< Ret > > | Cgu::Thread::make_future (Func &&functor)